&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*--------------------------------------------------------------------------
    File        : toolbarcustom.p
    Purpose     : Super procedure to extend toolbar class.

    Syntax      : rtb/admtwo/custom/toolbarcustom.p

    Modified    : 05/31/1999
  ------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

&SCOPED-DEFINE ADMSuper toolbarcustom.p

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&IF DEFINED(EXCLUDE-initializeMenu) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD initializeMenu Procedure 
FUNCTION initializeMenu RETURNS LOGICAL
  ( )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 15
         WIDTH              = 60.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB Procedure 
/* ************************* Included-Libraries *********************** */

{rtb/admtwo/toolprop.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-initAction) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initAction Procedure 
PROCEDURE initAction :
/*------------------------------------------------------------------------------
  Purpose:     Add the 'Search' action
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  
  RUN SUPER.

  DYNAMIC-FUNCTION('defineAction':U IN TARGET-PROCEDURE,
    "Search",                                    /* ActionID */
    "Name,Caption,Image,Type,OnChoose,Parent":U, /* Attr list*/
    "Search" + CHR(1) +                          /* Name */
    "&Find Record" + CHR(1) +                    /* Caption */
    "select.bmp" + CHR(1) +                      /* Image */
    "PUBLISH":U + CHR(1) +                       /* Type */
    "evRtbFindRecord":U + CHR(1) +               /* OnChoose */
    "Function":U).                               /* Parent */

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-queryPosition) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE queryPosition Procedure 
PROCEDURE queryPosition :
/*------------------------------------------------------------------------------
  Purpose:     Local override of queryPosition code to enable Search button
  Parameters:  pcState - Query position as reported by SDO
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER pcState AS CHARACTER   NO-UNDO.

  DYNAMIC-FUNCTION('enableActions':U IN TARGET-PROCEDURE,"Search":U).
  
  RUN SUPER(pcState).

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-setButtons) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setButtons Procedure 
PROCEDURE setButtons :
/*-------------------------------------------------------------------
  Purpose    : Local override of the standard setButtons code.
               Checks cases to enable and disable the Search button.
  Parameters : pcState -- look for 'initial-tableio' and 'add-only'
--------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER pcState AS CHAR NO-UNDO.

  CASE pcState:
    /*
     Enable Search button when Tableio-target
    */
    WHEN 'Initial-TableIO':U THEN
      DYNAMIC-FUNCTION('enableActions':U IN TARGET-PROCEDURE,'Search':U).
    /*
     and disable it if no record available
    */
    WHEN 'Add-Only':U THEN
      DYNAMIC-FUNCTION('disableActions':U IN TARGET-PROCEDURE,'Search':U).
  END CASE.

  RUN SUPER(pcState).

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-updateState) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE updateState Procedure 
PROCEDURE updateState :
/*------------------------------------------------------------------------------
  Purpose:     Local override of updateState code to disable Search button
               during record updates.
  Parameters:  pcState - "Update" or "UpdateComplete"
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER pcState AS CHARACTER   NO-UNDO.
  
  CASE pcState:
    WHEN "Update" THEN
      DYNAMIC-FUNCTION('disableActions':U IN TARGET-PROCEDURE,'Search':U).
    WHEN "UpdateComplete" THEN
      DYNAMIC-FUNCTION('enableActions':U IN TARGET-PROCEDURE,'Search':U).
  END CASE.

  RUN SUPER(pcState).

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

/* ************************  Function Implementations ***************** */

&IF DEFINED(EXCLUDE-initializeMenu) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION initializeMenu Procedure 
FUNCTION initializeMenu RETURNS LOGICAL
  ( ) :
/*------------------------------------------------------------------------------
  Purpose:  Local "override" of initializeMenu code
    Notes:  Since toolbar menu is either all standard or all custom, the
            statndard code is duplicated here in this "custom" override. It
            is necessary to choose the all custom route in order to include 
            customizations
------------------------------------------------------------------------------*/
  DYNAMIC-FUNCTION ('insertMenu':U IN TARGET-PROCEDURE,
    "":U, "File,Navigation,Search":U, NO, ?).
  
  DYNAMIC-FUNCTION ('insertMenu':U IN TARGET-PROCEDURE,
    "File":U,
    "Add,Update,Copy,Delete,RULE,":U +
    "Save,Reset,Cancel,RULE,Transaction,":U +
    "RULE,Function,RULE,Exit":U, YES, ?).

  RETURN TRUE.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

