&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*------------------------------------------------------------------------
    File        : rtb_rpt_repo.p
    Description : Repository reports library

    Author(s)   :
    Created     : 
    Notes       : 
  ----------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
{rtb/i/rtb_rptinit.i}

DEFINE VARIABLE Mcur-block        AS INTEGER     NO-UNDO.
DEFINE VARIABLE Mhead-dsite       AS INTEGER     NO-UNDO.
DEFINE VARIABLE Mhead-rep-address AS INTEGER     NO-UNDO.
DEFINE VARIABLE Mdisplay-support  AS LOGICAL     NO-UNDO.
DEFINE VARIABLE Mproblem-found    AS LOGICAL     NO-UNDO.

DEFINE TEMP-TABLE TTver
   FIELD dsite         LIKE rtb.rtb_ver.dsite
   FIELD rep-address   LIKE rtb.rtb_ver.rep-address
   FIELD root-ver      LIKE rtb.rtb_ver.root-ver
   FIELD rtb_ver-rowid AS ROWID
   INDEX ver-repo IS PRIMARY
      dsite
      rep-address
   INDEX root-repo
      root-ver.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 15
         WIDTH              = 60.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-rptRtbRepositoryCheck) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbRepositoryCheck Procedure 
PROCEDURE rptRtbRepositoryCheck :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  INPUT TABLE-HANDLE PhTT - Filespecs temp-table
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER PchkRepoVer  AS LOGICAL NO-UNDO.
  DEFINE INPUT PARAMETER PchkRepoLink AS LOGICAL NO-UNDO.
  DEFINE INPUT PARAMETER PchkEmptyObj AS LOGICAL NO-UNDO.
  DEFINE INPUT PARAMETER PchkObjRoot  AS LOGICAL NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.

  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).

  RUN rtb_repository_check_report (INPUT PchkRepoVer,
                                   INPUT PchkRepoLink,
                                   INPUT PchkEmptyObj,
                                   INPUT PchkObjRoot).

  OUTPUT STREAM Sout CLOSE.

  /*
   Return the return value of the above procedure
  */
  RETURN RETURN-VALUE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_check_binary_versions) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_check_binary_versions Procedure 
PROCEDURE rtb_check_binary_versions PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Check binary repository records against object version records
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE BUFFER BTTver    FOR TTver.
  DEFINE BUFFER Brtb_repo FOR rtb.rtb_brepo.
  DEFINE BUFFER Brtb_ver  FOR rtb.rtb_ver.
  DEFINE BUFFER B2rtb_ver FOR rtb.rtb_ver.

  PUT STREAM Sout UNFORMATTED
    SKIP(1)
    "Checking binary repository records against object version records "
    "(" STRING(TIME,"HH:MM:SS") ")..."
    SKIP(1).

   Mproblem-found = NO.     
  
  FOR EACH Brtb_repo NO-LOCK:

    IF Brtb_repo.rep-block = 1 THEN DO:

      /*
       Find the version record for this repository record.
      */
      FIND FIRST TTver 
        WHERE TTver.dsite       = Brtb_repo.dsite
          AND TTver.rep-address = Brtb_repo.rep-address NO-LOCK NO-ERROR.

      /*
       Does a version record exist for this repository record?
      */
      IF AVAILABLE TTver THEN DO:
        /*
         Are there more than one version records for this repository record? 
        */
        FIND BTTver WHERE ROWID(BTTver) = ROWID(TTver) NO-LOCK.

        FIND NEXT BTTver
          WHERE BTTver.dsite       = Brtb_repo.dsite
            AND BTTver.rep-address = Brtb_repo.rep-address NO-LOCK NO-ERROR.

        IF AVAILABLE BTTver THEN DO:
          ASSIGN Mproblem-found = YES.

          /*
           Multiple version records exist for current repository record!
          */
          FIND FIRST Brtb_ver
            WHERE ROWID(Brtb_ver) = TTver.rtb_ver-rowid NO-LOCK.

          PUT STREAM Sout UNFORMATTED
            "  Error: Multiple version recs for binary repo rec "
            " site: " Brtb_repo.dsite
            " addr: " Brtb_repo.rep-address
            " blk: "  Brtb_repo.rep-block
            SKIP
            "    version  pmod: " Brtb_ver.pmod
            " type: "             Brtb_ver.obj-type
            " obj: "              Brtb_ver.object
            " ver: "              Brtb_ver.version FORMAT "999999"
            SKIP.

          FOR EACH BTTver
            WHERE BTTver.dsite       =  Brtb_repo.dsite
              AND BTTver.rep-address =  Brtb_repo.rep-address
              AND ROWID(BTTver)      <> ROWID(TTver) NO-LOCK: 

            FIND FIRST B2rtb_ver
              WHERE ROWID(B2rtb_ver) = BTTver.rtb_ver-rowid NO-LOCK.

            PUT STREAM Sout UNFORMATTED
              "    version  pmod: "  B2rtb_ver.pmod
              " type: "              B2rtb_ver.obj-type
              " obj: "               B2rtb_ver.object
              " ver: "               B2rtb_ver.version FORMAT "999999"
              SKIP.
          END.  /* for each bTTver */

        END.  /* if available bTTver then */
       
      END.  /* if available TTver then */
      ELSE DO:
        /*
         The find on the version record in the temporary table
         failed...  This may mean that no version record exists for
         this repository record or that this repository record may
         have been created after the version temporary table was
         built.  To ensure that it is not the latter case, try
         finding the version record in the real database rather than
         the version temporary table.  This find is completely 
         unindexed and will be very slow.
        */
        FIND FIRST Brtb_ver
          WHERE Brtb_ver.dsite       = Brtb_repo.dsite
            AND Brtb_ver.rep-address = Brtb_repo.rep-address NO-LOCK NO-ERROR.

        IF NOT AVAILABLE Brtb_ver THEN DO:
          Mproblem-found = YES.

          PUT STREAM Sout UNFORMATTED
            "  Error: No version rec for binary repo rec "
            " site: " Brtb_repo.dsite
            " addr: " Brtb_repo.rep-address
            " blk: "  Brtb_repo.rep-block
            SKIP.
        END.  /* if not available Brtb_ver then */
      
      END.  /* if available TTver else */

    END.  /* if rtb.rtb_repo.rep-block = 1 then */
    ELSE DO:
      /*
       If this is not the head of a repository record chain, then
       check that the current record belongs to the current chain.
      */
      IF Brtb_repo.dsite       <> Mhead-dsite
         OR Brtb_repo.rep-address <> Mhead-rep-address THEN DO:

        Mproblem-found = YES.

        /*
         If another record, but not of the current chain, then this is
         either a repository record that has become disconnected from
         its version record (that continues to exist), or a repository
         record for which no version record exists.

         Try to find a version record for this repository record.
        */
        FIND FIRST TTver
          WHERE TTver.dsite       = Brtb_repo.dsite
            AND TTver.rep-address = Brtb_repo.rep-address NO-LOCK NO-ERROR.

        IF AVAILABLE TTver THEN DO:
          FIND FIRST Brtb_ver
            WHERE ROWID(Brtb_ver) = TTver.rtb_ver-rowid NO-LOCK.

          DO Mcur-block = 1 TO Brtb_repo.rep-block - 1:
            PUT STREAM Sout UNFORMATTED
              "  Error: Brepo rec "
              " site: " TTver.dsite
              " addr: " TTver.rep-address
              " blk: "  Mcur-block
              " is missing for"
              SKIP
              "    version  pmod: " Brtb_ver.pmod
              " type: "             Brtb_ver.obj-type
              " obj: "              Brtb_ver.object
              " ver: "              Brtb_ver.version FORMAT "999999"
              SKIP.
          END.  /* do mcur-block = 1 to rtb.rtb_repo.rep-block -1 */
        END.  /* if available TTver then */
        ELSE
          PUT STREAM Sout UNFORMATTED
            "  Error: No version rec for binary repo rec "
            " site: " Brtb_repo.dsite
            " addr: " Brtb_repo.rep-address
            " blk: "  Brtb_repo.rep-block
            SKIP.
      END.  /* if Brtb_repo.dsite <> mhead-dsite or ... then */
    END.  /* if Brtb_repo.rep-block = 1 else */

     /*
      Record what repository chain we are currently processing
      and the what block of that chain was last read.
     */
     ASSIGN Mhead-dsite       = Brtb_repo.dsite
            Mhead-rep-address = Brtb_repo.rep-address.

  END.  /* for each Brtb_repo */
   
  IF Mproblem-found THEN
    Mdisplay-support = YES.
  ELSE
    PUT STREAM Sout UNFORMATTED
      "  No problems were found." SKIP.  

 RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_check_empty_versions) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_check_empty_versions Procedure 
PROCEDURE rtb_check_empty_versions PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Check for empty object versions (versions lacking data)
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mi AS INTEGER    NO-UNDO.

  DEFINE BUFFER Brtb_brepo FOR rtb.rtb_brepo.
  DEFINE BUFFER Brtb_repo  FOR rtb.rtb_repo.
  DEFINE BUFFER Brtb_ver   FOR rtb.rtb_ver.

  PUT STREAM Sout UNFORMATTED
        SKIP(1)
        "Checking for empty object versions "
        "(" STRING(TIME,"HH:MM:SS") ")..."
        SKIP(1).
  
  Mproblem-found = NO.
  
  /*
   The following is in a separate loop to isolate its display...
  
   Check that there is a head repository record for each object root
   version record.  The absence of repository records for a version
   record is not necessarily an error.  It may simply mean that there
   were no changes made in that version.  This sounds odd, but users
   will inevitably find reasons to do this.  I think it is even more
   odd to find a root version that has no repository records.  This
   would mean that that version of the object is an empty file.
   This kind of situation is probably worth reporting...
  */
  FOR EACH TTver WHERE TTver.root-ver = YES NO-LOCK:
  
    FIND FIRST Brtb_ver WHERE
      ROWID(Brtb_ver) = TTver.rtb_ver-rowid NO-LOCK.

    IF Brtb_ver.storage-method = "R" THEN DO:
      /*
       Check each part of rtb_ver record
      */
      DO Mi = 1 TO 10:
        IF Brtb_ver.parts-used[Mi] = TRUE THEN DO:
          IF NOT CAN-FIND(FIRST Brtb_brepo
                          WHERE Brtb_brepo.dsite       = Brtb_ver.dsite
                            AND Brtb_brepo.rep-address = Brtb_ver.rep-address
                            AND Brtb_brepo.part-num    = Mi
                            AND Brtb_brepo.rep-block   = 1) THEN DO:
        
            Mproblem-found = YES.
  
            PUT STREAM Sout UNFORMATTED
              "  Warning: No data exists for"
              SKIP
              "    version  pmod: " Brtb_ver.pmod
              " type: "             Brtb_ver.obj-type
              " obj: "              Brtb_ver.object
              " part: "             Mi
              " ver: "              Brtb_ver.version FORMAT "999999"
              SKIP.
          END.  /* not can-find brtb_brepo */
        END. /* parts-used */
      END. /* Mi */
    END. /* storage method = R */
    ELSE DO:
      IF NOT CAN-FIND(Brtb_repo
                      WHERE Brtb_repo.dsite       = Brtb_ver.dsite
                        AND Brtb_repo.rep-address = Brtb_ver.rep-address
                        AND Brtb_repo.rep-block   = 1) THEN DO:
  
        Mproblem-found = YES.
  
        PUT STREAM Sout UNFORMATTED
          "  Warning: No data exists for"
          SKIP
          "    version  pmod: " Brtb_ver.pmod
          " type: "             Brtb_ver.obj-type
          " obj: "              Brtb_ver.object
          " ver: "              Brtb_ver.version FORMAT "999999"
           SKIP.
      
      END.  /* not can-find brtb_repo */
    END. /* else */
  END.  /* for each TTver */
  
  IF Mproblem-found THEN
    Mdisplay-support = YES.
  ELSE
    PUT STREAM Sout UNFORMATTED "  No problems were found." SKIP.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_check_repo_links) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_check_repo_links Procedure 
PROCEDURE rtb_check_repo_links PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE BUFFER Brtb_repo  FOR rtb.rtb_repo.
  DEFINE BUFFER B2rtb_repo FOR rtb.rtb_repo.
  DEFINE BUFFER Brtb_ver   FOR rtb.rtb_ver.
  
  DEFINE VARIABLE Mlast-e AS INTEGER   NO-UNDO.

  PUT STREAM Sout UNFORMATTED
    SKIP(1)
    "Checking links between repository records "
    "(" STRING(TIME,"HH:MM:SS") ")..."
    SKIP(1).
  
  Mproblem-found = NO.
  
  /*
   For each object root version, check the linked list of repository
   records to see if any repository records appear to be missing.
   Note that we can only check the completeness of root versions.
  */
  FOR EACH TTver WHERE TTver.root-ver = YES NO-LOCK:

    FIND FIRST Brtb_ver
       WHERE ROWID(Brtb_ver) = TTver.rtb_ver-rowid NO-LOCK.
  
    Mcur-block = 1.
   
    IF Brtb_ver.storage-method = "R" THEN DO:
      /*
       I don't think there is really anything to do here for binary 
       repo records since there is no "E" flag for them.  I was going to
       check for a missing rep-block but the section below for regular
       repo records isn't doing that.  Besides, if a chunk of their binary
       file is missing, they will notice it right away. - JAL
      */    
    END.
    ELSE DO:  
      FIND Brtb_repo
        WHERE Brtb_repo.dsite       = TTver.dsite
          AND Brtb_repo.rep-address = TTver.rep-address
          AND Brtb_repo.rep-block   = Mcur-block
        NO-LOCK NO-ERROR.
  
      /*
       Do not worry if the head repository record does not exist...
       some of the earlier checks will have already complained.
       Loop looking for the next repository record in the list
       as long as the current record is not the last.
      */
      DO WHILE AVAILABLE Brtb_repo:
        Mcur-block = Mcur-block + 1.
        FIND Brtb_repo
          WHERE Brtb_repo.dsite       = TTver.dsite
            AND Brtb_repo.rep-address = TTver.rep-address
            AND Brtb_repo.rep-block   = Mcur-block
          NO-LOCK NO-ERROR.
  
        /*
         End of linked list of repository records found.
        */
        IF NOT AVAILABLE Brtb_repo THEN DO:
          /*
           The previous repository record was the last in
           the linked list... go find it again.
          */
          FIND B2rtb_repo
            WHERE B2rtb_repo.dsite       = TTver.dsite
              AND B2rtb_repo.rep-address = TTver.rep-address
              AND B2rtb_repo.rep-block   = Mcur-block - 1
            NO-LOCK.
  
          /*
           Look for the last "E" line (if it exists at all).
          */
          IF B2rtb_repo.t100 = "E" THEN
            ASSIGN Mlast-e = 100.
          ELSE IF B2rtb_repo.t099 = "E" THEN ASSIGN Mlast-e = 99.
          ELSE IF B2rtb_repo.t098 = "E" THEN ASSIGN Mlast-e = 98.
          ELSE IF B2rtb_repo.t097 = "E" THEN ASSIGN Mlast-e = 97.
          ELSE IF B2rtb_repo.t096 = "E" THEN ASSIGN Mlast-e = 96.
          ELSE IF B2rtb_repo.t095 = "E" THEN ASSIGN Mlast-e = 95.
          ELSE IF B2rtb_repo.t094 = "E" THEN ASSIGN Mlast-e = 94.
          ELSE IF B2rtb_repo.t093 = "E" THEN ASSIGN Mlast-e = 93.
          ELSE IF B2rtb_repo.t092 = "E" THEN ASSIGN Mlast-e = 92.
          ELSE IF B2rtb_repo.t091 = "E" THEN ASSIGN Mlast-e = 91.
          ELSE IF B2rtb_repo.t090 = "E" THEN ASSIGN Mlast-e = 90.
          ELSE IF B2rtb_repo.t089 = "E" THEN ASSIGN Mlast-e = 89.
          ELSE IF B2rtb_repo.t088 = "E" THEN ASSIGN Mlast-e = 88.
          ELSE IF B2rtb_repo.t087 = "E" THEN ASSIGN Mlast-e = 87.
          ELSE IF B2rtb_repo.t086 = "E" THEN ASSIGN Mlast-e = 86.
          ELSE IF B2rtb_repo.t085 = "E" THEN ASSIGN Mlast-e = 85.
          ELSE IF B2rtb_repo.t084 = "E" THEN ASSIGN Mlast-e = 84.
          ELSE IF B2rtb_repo.t083 = "E" THEN ASSIGN Mlast-e = 83.
          ELSE IF B2rtb_repo.t082 = "E" THEN ASSIGN Mlast-e = 82.
          ELSE IF B2rtb_repo.t081 = "E" THEN ASSIGN Mlast-e = 81.
          ELSE IF B2rtb_repo.t080 = "E" THEN ASSIGN Mlast-e = 80.
          ELSE IF B2rtb_repo.t079 = "E" THEN ASSIGN Mlast-e = 79.
          ELSE IF B2rtb_repo.t078 = "E" THEN ASSIGN Mlast-e = 78.
          ELSE IF B2rtb_repo.t077 = "E" THEN ASSIGN Mlast-e = 77.
          ELSE IF B2rtb_repo.t076 = "E" THEN ASSIGN Mlast-e = 76.
          ELSE IF B2rtb_repo.t075 = "E" THEN ASSIGN Mlast-e = 75.
          ELSE IF B2rtb_repo.t074 = "E" THEN ASSIGN Mlast-e = 74.
          ELSE IF B2rtb_repo.t073 = "E" THEN ASSIGN Mlast-e = 73.
          ELSE IF B2rtb_repo.t072 = "E" THEN ASSIGN Mlast-e = 72.
          ELSE IF B2rtb_repo.t071 = "E" THEN ASSIGN Mlast-e = 71.
          ELSE IF B2rtb_repo.t070 = "E" THEN ASSIGN Mlast-e = 70.
          ELSE IF B2rtb_repo.t069 = "E" THEN ASSIGN Mlast-e = 69.
          ELSE IF B2rtb_repo.t068 = "E" THEN ASSIGN Mlast-e = 68.
          ELSE IF B2rtb_repo.t067 = "E" THEN ASSIGN Mlast-e = 67.
          ELSE IF B2rtb_repo.t066 = "E" THEN ASSIGN Mlast-e = 66.
          ELSE IF B2rtb_repo.t065 = "E" THEN ASSIGN Mlast-e = 65.
          ELSE IF B2rtb_repo.t064 = "E" THEN ASSIGN Mlast-e = 64.
          ELSE IF B2rtb_repo.t063 = "E" THEN ASSIGN Mlast-e = 63.
          ELSE IF B2rtb_repo.t062 = "E" THEN ASSIGN Mlast-e = 62.
          ELSE IF B2rtb_repo.t061 = "E" THEN ASSIGN Mlast-e = 61.
          ELSE IF B2rtb_repo.t060 = "E" THEN ASSIGN Mlast-e = 60.
          ELSE IF B2rtb_repo.t059 = "E" THEN ASSIGN Mlast-e = 59.
          ELSE IF B2rtb_repo.t058 = "E" THEN ASSIGN Mlast-e = 58.
          ELSE IF B2rtb_repo.t057 = "E" THEN ASSIGN Mlast-e = 57.
          ELSE IF B2rtb_repo.t056 = "E" THEN ASSIGN Mlast-e = 56.
          ELSE IF B2rtb_repo.t055 = "E" THEN ASSIGN Mlast-e = 55.
          ELSE IF B2rtb_repo.t054 = "E" THEN ASSIGN Mlast-e = 54.
          ELSE IF B2rtb_repo.t053 = "E" THEN ASSIGN Mlast-e = 53.
          ELSE IF B2rtb_repo.t052 = "E" THEN ASSIGN Mlast-e = 52.
          ELSE IF B2rtb_repo.t051 = "E" THEN ASSIGN Mlast-e = 51.
          ELSE IF B2rtb_repo.t050 = "E" THEN ASSIGN Mlast-e = 50.
          ELSE IF B2rtb_repo.t049 = "E" THEN ASSIGN Mlast-e = 49.
          ELSE IF B2rtb_repo.t048 = "E" THEN ASSIGN Mlast-e = 48.
          ELSE IF B2rtb_repo.t047 = "E" THEN ASSIGN Mlast-e = 47.
          ELSE IF B2rtb_repo.t046 = "E" THEN ASSIGN Mlast-e = 46.
          ELSE IF B2rtb_repo.t045 = "E" THEN ASSIGN Mlast-e = 45.
          ELSE IF B2rtb_repo.t044 = "E" THEN ASSIGN Mlast-e = 44.
          ELSE IF B2rtb_repo.t043 = "E" THEN ASSIGN Mlast-e = 43.
          ELSE IF B2rtb_repo.t042 = "E" THEN ASSIGN Mlast-e = 42.
          ELSE IF B2rtb_repo.t041 = "E" THEN ASSIGN Mlast-e = 41.
          ELSE IF B2rtb_repo.t040 = "E" THEN ASSIGN Mlast-e = 40.
          ELSE IF B2rtb_repo.t039 = "E" THEN ASSIGN Mlast-e = 39.
          ELSE IF B2rtb_repo.t038 = "E" THEN ASSIGN Mlast-e = 38.
          ELSE IF B2rtb_repo.t037 = "E" THEN ASSIGN Mlast-e = 37.
          ELSE IF B2rtb_repo.t036 = "E" THEN ASSIGN Mlast-e = 36.
          ELSE IF B2rtb_repo.t035 = "E" THEN ASSIGN Mlast-e = 35.
          ELSE IF B2rtb_repo.t034 = "E" THEN ASSIGN Mlast-e = 34.
          ELSE IF B2rtb_repo.t033 = "E" THEN ASSIGN Mlast-e = 33.
          ELSE IF B2rtb_repo.t032 = "E" THEN ASSIGN Mlast-e = 32.
          ELSE IF B2rtb_repo.t031 = "E" THEN ASSIGN Mlast-e = 31.
          ELSE IF B2rtb_repo.t030 = "E" THEN ASSIGN Mlast-e = 30.
          ELSE IF B2rtb_repo.t029 = "E" THEN ASSIGN Mlast-e = 29.
          ELSE IF B2rtb_repo.t028 = "E" THEN ASSIGN Mlast-e = 28.
          ELSE IF B2rtb_repo.t027 = "E" THEN ASSIGN Mlast-e = 27.
          ELSE IF B2rtb_repo.t026 = "E" THEN ASSIGN Mlast-e = 26.
          ELSE IF B2rtb_repo.t025 = "E" THEN ASSIGN Mlast-e = 25.
          ELSE IF B2rtb_repo.t024 = "E" THEN ASSIGN Mlast-e = 24.
          ELSE IF B2rtb_repo.t023 = "E" THEN ASSIGN Mlast-e = 23.
          ELSE IF B2rtb_repo.t022 = "E" THEN ASSIGN Mlast-e = 22.
          ELSE IF B2rtb_repo.t021 = "E" THEN ASSIGN Mlast-e = 21.
          ELSE IF B2rtb_repo.t020 = "E" THEN ASSIGN Mlast-e = 20.
          ELSE IF B2rtb_repo.t019 = "E" THEN ASSIGN Mlast-e = 19.
          ELSE IF B2rtb_repo.t018 = "E" THEN ASSIGN Mlast-e = 18.
          ELSE IF B2rtb_repo.t017 = "E" THEN ASSIGN Mlast-e = 17.
          ELSE IF B2rtb_repo.t016 = "E" THEN ASSIGN Mlast-e = 16.
          ELSE IF B2rtb_repo.t015 = "E" THEN ASSIGN Mlast-e = 15.
          ELSE IF B2rtb_repo.t014 = "E" THEN ASSIGN Mlast-e = 14.
          ELSE IF B2rtb_repo.t013 = "E" THEN ASSIGN Mlast-e = 13.
          ELSE IF B2rtb_repo.t012 = "E" THEN ASSIGN Mlast-e = 12.
          ELSE IF B2rtb_repo.t011 = "E" THEN ASSIGN Mlast-e = 11.
          ELSE IF B2rtb_repo.t010 = "E" THEN ASSIGN Mlast-e = 10.
          ELSE IF B2rtb_repo.t009 = "E" THEN ASSIGN Mlast-e = 9.
          ELSE IF B2rtb_repo.t008 = "E" THEN ASSIGN Mlast-e = 8.
          ELSE IF B2rtb_repo.t007 = "E" THEN ASSIGN Mlast-e = 7.
          ELSE IF B2rtb_repo.t006 = "E" THEN ASSIGN Mlast-e = 6.
          ELSE IF B2rtb_repo.t005 = "E" THEN ASSIGN Mlast-e = 5.
          ELSE IF B2rtb_repo.t004 = "E" THEN ASSIGN Mlast-e = 4.
          ELSE IF B2rtb_repo.t003 = "E" THEN ASSIGN Mlast-e = 3.
          ELSE IF B2rtb_repo.t002 = "E" THEN ASSIGN Mlast-e = 2.
          ELSE IF B2rtb_repo.t001 = "E" THEN ASSIGN Mlast-e = 1.
          ELSE ASSIGN Mlast-e = 0.
  
          IF Mlast-e = 0 THEN DO:
            Mproblem-found = YES.
  
            PUT STREAM Sout UNFORMATTED
              "  Warning: Repo rec "
              " site: "      TTver.dsite
              " addr: "      TTver.rep-address
              " blk: "       Mcur-block
              " has no terminator"
              SKIP
              "    version  pmod: " Brtb_ver.pmod
              " type: "             Brtb_ver.obj-type
              " obj: "              Brtb_ver.object
              " ver: "              Brtb_ver.version FORMAT "999999"
              SKIP.
          END.  /* if mlast-e = 0 then */
          ELSE
            /*
             Older versions of RTB (2.2C and earlier) set the repository
             number of lines to one line longer than the actual file.
             
             Newer versions of RTB (3.0A and later) do not suffer this
             problem.  For example:

               In an older version of RTB
                 - a 100 line program would require 2 repo recs with the
                   100 lines stored in the first rec and an "E" in line 1
                   of the second rec.  The first rec would have num-lines
                   set to 101 and the second rec would have num-lines set
                   to 2.
                 - a 99 line program would require 1 repo rec with the 99
                   lines stored in lines 1 to 99 of the rec, an "E" at line
                   100, and the num-lines set to 101.

               In a newer version of RTB
                 - a 100 line program would require 2 repo recs with the
                   100 lines stored in the first rec and an "E" in line 1
                   of the second rec.  The first rec would have num-lines
                   set to 100 and the second rec would have num-lines set
                   to 1.
                 - a 99 line program would require 1 repo rec with the 99
                   lines stored in lines 1 to 99 of the rec, an "E" at line
                   100, and the num-lines set to 100.
               
             Accept both of these values and complain about any others.
            */
            IF Mlast-e <> B2rtb_repo.num-lines
               AND Mlast-e <> B2rtb_repo.num-lines - 1 THEN DO:

              Mproblem-found = YES.
  
              PUT STREAM Sout UNFORMATTED
                "  Warning: Repo rec "
                " site: "  TTver.dsite
                " addr: "  TTver.rep-address
                " blk: "   Mcur-block
                " has wrong num lines for"
                SKIP
                "    version  pmod: " Brtb_ver.pmod
                " type: "             Brtb_ver.obj-type
                " obj: "              Brtb_ver.object
                " ver: "              Brtb_ver.version FORMAT "999999"
                SKIP
                "    (it should have: " B2rtb_repo.NUM-LINES
                " lines, but actual num of lines is: " Mlast-e ")"
                SKIP.
            END.  /* if mlast-e <> B2rtb_repo.num-lines and... then */
        
        END.  /* if not available Brtb_repo then */
  
      END.  /* do while available Brtb_repo */
  
    END. /* else */
   
  END.  /* for each TTver */
  
  IF Mproblem-found THEN
    Mdisplay-support = YES.
  ELSE
    PUT STREAM Sout UNFORMATTED
       "  No problems were found."
       SKIP.
  
  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_check_root_versions) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_check_root_versions Procedure 
PROCEDURE rtb_check_root_versions PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Check for the existence of object root (full source) versions 
               records.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE BUFFER Brtb_ver  FOR rtb.rtb_ver.
  DEFINE BUFFER B2rtb_ver FOR rtb.rtb_ver.

  PUT STREAM Sout UNFORMATTED
    SKIP(1)
    "Checking object delta versions have prior full source versions "
    "(" STRING(TIME,"HH:MM:SS") ")..."
    SKIP(1).
  
  Mproblem-found = NO.
  
  /*
   For each object non-root (delta) version record check that there is
   a prior object root (full source) version record.  An object's first
   version record must be an object root version record.  Subsequent
   object version records may or may not be object root version records.
  */
  FOR EACH TTver WHERE TTver.root-ver = NO NO-LOCK:
  
    FIND FIRST Brtb_ver
       WHERE ROWID(Brtb_ver) = TTver.rtb_ver-rowid NO-LOCK.
  
    /*
     Find a prior object root (full source) version record for this
     object non-root (delta) version record.
    */
    FIND FIRST B2rtb_ver
       WHERE B2rtb_ver.pmod     = Brtb_ver.pmod
         AND B2rtb_ver.obj-type = Brtb_ver.obj-type
         AND B2rtb_ver.object   = Brtb_ver.object
         AND B2rtb_ver.version  < Brtb_ver.version
         AND B2rtb_ver.root-ver = YES
       NO-LOCK NO-ERROR.
  
    IF NOT AVAILABLE B2rtb_ver THEN DO:
      Mproblem-found = YES.

    PUT STREAM Sout UNFORMATTED
      "  Error: No prior full source version rec for delta version rec"
      SKIP
      "    version  pmod: "  Brtb_ver.pmod
      " type: "              Brtb_ver.obj-type
      " obj: "               Brtb_ver.object
      " ver: "               Brtb_ver.version FORMAT "999999"
      SKIP.
    END.  /* if not available B2rtb_ver then */
  END.  /* for each TTver */
  
  IF Mproblem-found THEN
    Mdisplay-support = YES.
  ELSE
    PUT STREAM Sout UNFORMATTED "  No problems were found." SKIP.
         
  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_check_text_versions) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_check_text_versions Procedure 
PROCEDURE rtb_check_text_versions PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Check text repository records against object version records
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE BUFFER BTTver    FOR TTver.
  DEFINE BUFFER Brtb_repo FOR rtb.rtb_repo.
  DEFINE BUFFER Brtb_ver  FOR rtb.rtb_ver.
  DEFINE BUFFER B2rtb_ver FOR rtb.rtb_ver.
   
  PUT STREAM Sout UNFORMATTED
      SKIP(1)
      "Checking repository records against object version records "
      "(" STRING(TIME,"HH:MM:SS") ")..."
      SKIP(1).

  Mproblem-found = NO.

  /*
  Scan through all the repository records checking the object
  version records that exist, or do not exist, for each.
  */
  FOR EACH Brtb_repo NO-LOCK:
  
   IF Brtb_repo.rep-block = 1 THEN DO:
     /*
      Find the version record for this repository record.
     */
     FIND FIRST TTver
       WHERE TTver.dsite       = Brtb_repo.dsite
         AND TTver.rep-address = Brtb_repo.rep-address
       NO-LOCK NO-ERROR.
  
     /*
      Does a version record exist for this repository record?
     */
     IF AVAILABLE TTver THEN DO:
       /*
        Are there more than one version records for this
        repository record?
       */
       FIND BTTver WHERE ROWID(BTTver) = ROWID(TTver) NO-LOCK.
       FIND NEXT BTTver
         WHERE BTTver.dsite       = Brtb_repo.dsite
           AND BTTver.rep-address = Brtb_repo.rep-address
           NO-LOCK NO-ERROR.
  
       IF AVAILABLE BTTver THEN DO:
         Mproblem-found = YES.
  
         /*
          Multiple version records exist for current repository record!
         */
         FIND FIRST Brtb_ver
           WHERE ROWID(Brtb_ver) = TTver.rtb_ver-rowid NO-LOCK.
  
         PUT STREAM Sout UNFORMATTED
           "  Error: Multiple version recs for repo rec "
           " site: "             Brtb_repo.dsite
           " addr: "             Brtb_repo.rep-address
           " blk: "              Brtb_repo.rep-block
           SKIP
           "    version  pmod: " Brtb_ver.pmod
           " type: "             Brtb_ver.obj-type
           " obj: "              Brtb_ver.object
           " ver: "              Brtb_ver.version FORMAT "999999"
           SKIP.
  
           FOR EACH BTTver
              WHERE BTTver.dsite       =  Brtb_repo.dsite
                AND BTTver.rep-address =  Brtb_repo.rep-address
                AND ROWID(BTTver)      <> ROWID(TTver)
              NO-LOCK:
  
              FIND FIRST B2rtb_ver
                 WHERE ROWID(B2rtb_ver) = BTTver.rtb_ver-rowid NO-LOCK.
  
              PUT STREAM Sout UNFORMATTED
                "    version  pmod: " B2rtb_ver.pmod
                " type: "             B2rtb_ver.obj-type
                " obj: "              B2rtb_ver.object
                " ver: "              B2rtb_ver.version FORMAT "999999"
                SKIP.
           END.  /* for each bttver */
  
          END.  /* if available bTTver then */
       END.  /* if available TTver then */
       ELSE DO:
         /*
          The find on the version record in the temporary table failed...
          This may mean that no version record exists for this repository
          record or that this repository record may have been created
          after the version temporary table was built.  To ensure that
          it is not the latter case, try finding the version record in
          the real database rather than the version temporary table.
          This find is completely unindexed and will be very slow.
         */
         FIND FIRST Brtb_ver
           WHERE Brtb_ver.dsite       = Brtb_repo.dsite
             AND Brtb_ver.rep-address = Brtb_repo.rep-address
           NO-LOCK NO-ERROR.
  
         IF NOT AVAILABLE Brtb_ver THEN DO:
           Mproblem-found = YES.
  
           PUT STREAM Sout UNFORMATTED
             "  Error: No version rec for repo rec "
             " site: "  Brtb_repo.dsite
             " addr: "  Brtb_repo.rep-address
             " blk: "   Brtb_repo.rep-block
             SKIP.
         END.  /* if not available Brtb_ver then */
       END.  /* if available TTver else */
   END.  /* if Brtb_repo.rep-block = 1 then */
   ELSE DO:
      /*
       If this is not the head of a repository record chain, then
       check that the current record belongs to the current chain.
      */
      IF Brtb_repo.dsite       <> Mhead-dsite OR
         Brtb_repo.rep-address <> Mhead-rep-address THEN DO:
        Mproblem-found = YES.
  
        /*
         If another record, but not of the current chain, then this is
         either a repository record that has become disconnected from
         its version record (that continues to exist), or a repository
         record for which no version record exists.
  
         Try to find a version record for this repository record.
        */
        FIND FIRST TTver
          WHERE TTver.dsite       = Brtb_repo.dsite
            AND TTver.rep-address = Brtb_repo.rep-address
          NO-LOCK NO-ERROR.
  
        IF AVAILABLE TTver THEN DO:
          FIND FIRST Brtb_ver 
            WHERE ROWID(Brtb_ver) = TTver.rtb_ver-rowid NO-LOCK.
  
          DO Mcur-block = 1 TO Brtb_repo.rep-block - 1:
            PUT STREAM Sout UNFORMATTED
              "  Error: Repo rec "
              " site: "  TTver.dsite
              " addr: "  TTver.rep-address
              " blk: "   Mcur-block
              " is missing for"
              SKIP
              "    version  pmod: " Brtb_ver.pmod
              " type: "             Brtb_ver.obj-type
              " obj: "              Brtb_ver.object
              " ver: "              Brtb_ver.version FORMAT "999999"
              SKIP.
          END.  /* do mcur-block = 1 to Brtb_repo.rep-block -1 */
        END.  /* if available TTver then */
        ELSE
          PUT STREAM Sout UNFORMATTED
            "  Error: No version rec for repo rec "
            " site: " Brtb_repo.dsite
            " addr: " Brtb_repo.rep-address
            " blk: "  Brtb_repo.rep-block
            SKIP.
      END.  /* if Brtb_repo.dsite <> mhead-dsite or ... then */
    END.  /* if Brtb_repo.rep-block = 1 else */
  
    /* Record what repository chain we are currently processing */
    /* and the what block of that chain was last read.          */
    ASSIGN
       Mhead-dsite       = Brtb_repo.dsite
       Mhead-rep-address = Brtb_repo.rep-address.
  
  END.  /* for each Brtb_repo */
  
  IF Mproblem-found THEN
   Mdisplay-support = YES.
  ELSE
   PUT STREAM Sout UNFORMATTED "  No problems were found." SKIP.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_repository_check_report) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_repository_check_report Procedure 
PROCEDURE rtb_repository_check_report :
/*------------------------------------------------------------------------------
  Purpose:     Check the contents of the RTB repository.
                The repository is examined in four ways:

                1. Each repository record is checked to ensure that one
                   and only one object version record points to this
                   repository record.
                2. For each object root version record, the linked list
                   of repository records is traversed to see if any
                   repository records appear to be missing.
                3. All the object root version records are checked to
                   locate empty object versions (versions lacking data).
                4. For each object non-root (delta) version record, the
                   existence of a prior object root (full source) version
                   record is checked.

                Steps 2 and 3 could be combined, but are maintained as
                separate to keep the output of this report as simple
                as possible.

  Parameters:  INPUT
                  PchkRepoVer  - Check repository records against object
                                 version records
                  PchkRepoLink - Check links between repository records
                  PchkEmptyObj - Check for empty object versions 
                  PchkObjRoot  - Check for missing full source object versions

  Notes:       Existing indices make it quick and easy to locate
               rtb_repo records belonging to a rtb_ver record.  The
               reverse is not true.  There are no indices to help
               locate the rtb_ver record that a rtb_repo is owned by.
               To overcome this problem, all rtb_ver records are read
               into a temporary table which is indexed appropriately for
               this kind of searching.
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER PchkRepoVer  AS LOGICAL NO-UNDO.
  DEFINE INPUT PARAMETER PchkRepoLink AS LOGICAL NO-UNDO.
  DEFINE INPUT PARAMETER PchkEmptyObj AS LOGICAL NO-UNDO.
  DEFINE INPUT PARAMETER PchkObjRoot  AS LOGICAL NO-UNDO.

  DEFINE VARIABLE Merror AS CHARACTER   NO-UNDO INITIAL "".

  DEFINE BUFFER BTTver     FOR TTver.
  DEFINE BUFFER Brtb_brepo FOR rtb.rtb_brepo.
  DEFINE BUFFER Brtb_repo  FOR rtb.rtb_repo.
  DEFINE BUFFER Brtb_ver   FOR rtb.rtb_ver.
  DEFINE BUFFER B2rtb_ver  FOR rtb.rtb_ver.
  
  {rtb/i/rtb_rpthdr.i 
    &title="""Repository Check Report"""
    &criteria=""""
    &center-criteria=NO
    &STREAM=Sout}  
  
  PUT STREAM Sout UNFORMATTED
     SKIP(1)
     "Beginning repository check (" STRING(TIME,"HH:MM:SS") ")..."
     SKIP(1).
  
  /*
   Only build the temporary table of object version records
   if some or all of the reporting options that require the
   temporary table have been selected.
  */
  IF PchkRepoVer OR PchkRepoLink OR PchkEmptyObj OR PchkObjRoot THEN DO:
     PUT STREAM Sout UNFORMATTED
        SKIP(1)
        "Loading object version information into temporary table "
        "(" STRING(TIME,"HH:MM:SS") ")..."
        SKIP(1).
  
     /*
      Read object version records into a temporary table for fast access.
      Note that there are only repository records for PCODE and DOC
      objects, so we ignore version records of other object types.
      Also ignore any object version records that are not complete.
     */
     FOR EACH Brtb_ver
        WHERE (Brtb_ver.obj-type = "PCODE" OR Brtb_ver.obj-type  = "DOC")
        NO-LOCK:
  
        /*
         Skip work in progress versions.
        */
        IF Brtb_ver.obj-status = "W" THEN NEXT.
  
        CREATE TTver.
        ASSIGN TTver.dsite         = Brtb_ver.dsite
               TTver.rep-address   = Brtb_ver.rep-address
               TTver.root-ver      = Brtb_ver.root-ver
               TTver.rtb_ver-rowid = ROWID(Brtb_ver).
     END.
  
     PUT STREAM Sout UNFORMATTED "  Load complete." SKIP.
  END. /* if PchkRepoVer or PchkRepoLink or PchkEmptyObj or ... then */  

  IF PchkRepoVer THEN DO:
    /*
     Check text repository records
    */
    RUN rtb_check_text_versions.
    /*
     Check binary repository records
    */
    RUN rtb_check_binary_versions.
  END. /* if pchkrepover */

  IF PchkRepoLink THEN DO:
    /*
     Check links between repository records
    */
    RUN rtb_check_repo_links.
  END. /* if pchkrepolink */

  IF PchkEmptyObj THEN DO:
    RUN rtb_check_empty_versions.
  END.

  IF PchkObjRoot THEN DO:
    RUN rtb_check_root_versions.
  END.
  
  PUT STREAM Sout UNFORMATTED
     SKIP(2)
     "Finished repository check (" STRING(TIME,"HH:MM:SS") ")."
     SKIP.

  IF Mdisplay-support THEN
    PUT STREAM Sout UNFORMATTED
      SKIP(1)
      "Please contact Roundtable Technical Support for assistance with any errors detected by this report."
      SKIP.  

  RETURN Merror.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

