&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*------------------------------------------------------------------------
    File        : 
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     :
    Notes       :
  ----------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
{rtb/i/rtb_xreftype.i}
{rtb/i/rtb_rptinit.i}

/*
 Used in 'object_call_diagram' and 'build_structure_chart'
*/
DEFINE VARIABLE MnumLevels AS INTEGER  NO-UNDO.
DEFINE VARIABLE MtotLevels AS INTEGER  NO-UNDO.
DEFINE VARIABLE MmaxLevels AS INTEGER  NO-UNDO.
DEFINE VARIABLE MobjList   AS LONGCHAR NO-UNDO.
DEFINE VARIABLE MobjCtrl   AS LONGCHAR NO-UNDO.

/*
 Used in 'rtb_object_where_used'
*/
DEFINE TEMP-TABLE TTwhere NO-UNDO
  FIELD obj-guid    AS CHARACTER
  FIELD ref-type    AS CHARACTER LABEL "Ref Type"
  FIELD src-type    AS CHARACTER LABEL "Src Type"
  FIELD object      AS CHARACTER LABEL "Object"
  FIELD ref-actions AS CHARACTER LABEL "Actions"
  INDEX type-object IS PRIMARY
        src-type ASCENDING
        object   ASCENDING.

/*
 Used in 'rtb_index_usage'
*/
DEFINE TEMP-TABLE TTFile
  FIELD fileObject AS CHARACTER FORMAT "x(40)".

DEFINE TEMP-TABLE TTIndex
  FIELD fileObject AS CHARACTER FORMAT "x(40)"
  FIELD indexName  AS CHARACTER FORMAT "x(40)".

/*
 Use in 'rtb_external_objects'..
*/
DEFINE TEMP-TABLE ttXref LIKE rtb.rtb_xref
  INDEX ttXref1 IS PRIMARY wspace-guid ref-type obj-text.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 18.1
         WIDTH              = 55.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-rptRtbExternalObjects) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbExternalObjects Procedure 
PROCEDURE rptRtbExternalObjects :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace  AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.

  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).

  RUN rtb_external_objects (INPUT Pwspace).

  OUTPUT STREAM Sout CLOSE.

  RETURN RETURN-VALUE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rptRtbIndexUsage) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbIndexUsage Procedure 
PROCEDURE rptRtbIndexUsage :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace    AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER PunusedSum AS LOGICAL   NO-UNDO.
  DEFINE INPUT PARAMETER TABLE FOR TTFile.
  DEFINE INPUT PARAMETER TABLE FOR TTIndex.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.

  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).

  RUN rtb_index_usage (INPUT Pwspace, INPUT PunusedSum, INPUT TABLE TTFile, INPUT TABLE TTIndex).

  OUTPUT STREAM Sout CLOSE.

  RETURN RETURN-VALUE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rptRtbInformalXref) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbInformalXref Procedure 
PROCEDURE rptRtbInformalXref :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Ptype   AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Pobject AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.

  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).

  RUN rtb_informal_xref (Pwspace, Ptype, Pobject). 

  OUTPUT STREAM Sout CLOSE.

  RETURN RETURN-VALUE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rptRtbObjectCallDiagram) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbObjectCallDiagram Procedure 
PROCEDURE rptRtbObjectCallDiagram :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace     AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Pobject     AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER PmaxLevels  AS INTEGER   NO-UNDO.
  DEFINE INPUT PARAMETER PwhiteSpace AS INTEGER   NO-UNDO.
  DEFINE INPUT PARAMETER Pspacing    AS LOGICAL   NO-UNDO.
  DEFINE INPUT PARAMETER Ppmod       AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.

  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).

  RUN rtb_object_call_diagram (Pwspace, Pobject, PmaxLevels, PwhiteSpace, Pspacing, Ppmod).

  OUTPUT STREAM Sout CLOSE.

  RETURN RETURN-VALUE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rptRtbObjectUsageDiagram) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbObjectUsageDiagram Procedure 
PROCEDURE rptRtbObjectUsageDiagram :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace     AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Pobject     AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER PmaxLevels  AS INTEGER   NO-UNDO.
  DEFINE INPUT PARAMETER PwhiteSpace AS INTEGER   NO-UNDO.
  DEFINE INPUT PARAMETER Pspacing    AS LOGICAL   NO-UNDO.
  DEFINE INPUT PARAMETER Ppmod       AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.

  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).

  RUN rtb_object_usage_diagram (Pwspace, Pobject, PmaxLevels, PwhiteSpace, Pspacing, Ppmod).

  OUTPUT STREAM Sout CLOSE.

  RETURN RETURN-VALUE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rptRtbObjectWhereUsed) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbObjectWhereUsed Procedure 
PROCEDURE rptRtbObjectWhereUsed :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace  AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER PobjType AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Pobject  AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Ppmod    AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.

  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).

  RUN rtb_object_where_used (Pwspace, PobjType, Pobject, Ppmod).

  OUTPUT STREAM Sout CLOSE.

  RETURN RETURN-VALUE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rptRtbObjectXref) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbObjectXref Procedure 
PROCEDURE rptRtbObjectXref :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace  AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER PobjType AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Pobject  AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Ppmod    AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.

  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).

  RUN rtb_object_xref (Pwspace, PobjType, Pobject, Ppmod).

  OUTPUT STREAM Sout CLOSE.

  RETURN RETURN-VALUE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rptRtbUnusedObjects) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbUnusedObjects Procedure 
PROCEDURE rptRtbUnusedObjects :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace  AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.

  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).

  RUN rtb_unused_objects (INPUT Pwspace).

  OUTPUT STREAM Sout CLOSE.

  RETURN RETURN-VALUE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_build_structure_chart) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_build_structure_chart Procedure 
PROCEDURE rtb_build_structure_chart :
/*------------------------------------------------------------------------------
  Purpose:    Build a hierarchy of all programs, classes, etc ran from a given
              object 
  Parameters: PobjGuid - GUID of object to traverse  
  Notes:      MobjList and MobjCtrl are comma delimited lists.  
              MobjList contains the object names.
              MobjCtrl contains the level controls associated with each object entry 
              MnumLevels is the current number of levels reached
              MtotLevels is the total number of levels reached
              MmaxLevels is the maximum number of levels allowed
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER PobjGuid AS CHARACTER NO-UNDO.

  DEFINE VARIABLE Mpos   AS INTEGER NO-UNDO.  
  DEFINE VARIABLE Mxrefs AS LOGICAL NO-UNDO.

  DEFINE BUFFER Brtb_object FOR rtb.rtb_object.
  DEFINE BUFFER Brtb_xref   FOR rtb.rtb_xref.

  ASSIGN
    MnumLevels = MnumLevels + 1
    MtotLevels = MAX(MtotLevels, MnumLevels).

  FIND Brtb_object NO-LOCK
    WHERE Brtb_object.object-guid = PobjGuid NO-ERROR.

  IF AVAILABLE Brtb_object THEN DO:

    /*
     Mxrefs - does this object have rtb_xref records of type XREF_PROG,
              XREF_CLASS, or XREF_METHOD.
              i.e. does this program RUN another program, NEW a class,
              or INVOKE a method
     Mpos   - position in MobjList if it's already been added
    */
    ASSIGN
      Mxrefs = CAN-FIND(FIRST Brtb_xref
                        WHERE Brtb_xref.src-object-guid = Brtb_object.object-guid
                         AND (Brtb_xref.ref-type = {&XREF_PROG}  OR Brtb_xref.ref-type = {&XREF_CLASS}
                          OR (Brtb_xref.ref-type = {&XREF_METHOD} AND Brtb_xref.ref-actions <> "")))
                              
      Mpos   = LOOKUP(Brtb_object.object,MobjList).

    IF Mxrefs AND Mpos <> 0 THEN DO:
      ASSIGN MobjList = MobjList +
                         (IF MnumLevels > MmaxLevels THEN
                            "*"
                          ELSE  
                            "[" + TRIM(STRING(Mpos,">>>9")) + "]") +
                         Brtb_object.object + ",".
      MnumLevels = MnumLevels - 1.
      RETURN.
    END.
    ELSE   
      MobjList = MobjList +
                  (IF MnumLevels > MmaxLevels AND Mxrefs THEN
                     "*"
                   ELSE
                     "") +
                   Brtb_object.object + ",".

    IF NOT Mxrefs OR MnumLevels > MmaxLevels THEN DO:
      MnumLevels = MnumLevels - 1.
      RETURN.
    END.
  END.
  ELSE DO:
    ASSIGN MobjList = MobjList + ","
           MnumLevels = MnumLevels - 1.
    RETURN.
  END.

  /*
   Build temporary list of objects ran or methods invoked from the current
   object..
  */
  FOR EACH Brtb_xref NO-LOCK
    WHERE Brtb_xref.src-object-guid = Brtb_object.object-guid
     AND (Brtb_xref.ref-type = {&XREF_PROG}  OR Brtb_xref.ref-type = {&XREF_CLASS}
      OR (Brtb_xref.ref-type = {&XREF_METHOD} AND Brtb_xref.ref-actions <> ""))
    BREAK BY Brtb_xref.src-object-guid:

    MobjCtrl = MobjCtrl + TRIM(STRING(MnumLevels,">9")) + ",".

    /*
     Pass back the ROWID of the rtb_xref record when we have an external reference,
     or any informal object reference (INTPROC, METHOD). The call diagram report
     code can then find the record and get the appropriate string value.
    */
    IF Brtb_xref.ref-object-guid-1 = "" AND Brtb_xref.ref-type = {&XREF_PROG} THEN 
      MobjList = MobjList + "RV " + STRING(ROWID(Brtb_xref)) + ",". 
    ELSE IF Brtb_xref.ref-object-guid-1 = "" AND Brtb_xref.ref-type = {&XREF_METHOD} THEN 
      MobjList = MobjList + "IN " + STRING(ROWID(Brtb_xref)) + ",".
    ELSE
      RUN rtb_build_structure_chart (INPUT Brtb_xref.ref-object-guid-1).
  END.

  MnumLevels = MnumLevels - 1.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_build_structure_chart2) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_build_structure_chart2 Procedure 
PROCEDURE rtb_build_structure_chart2 :
/*------------------------------------------------------------------------------
  Purpose:     Build a hierarchy of all objects (and children) that use a given
               object.
  Parameters:  PobjGuid - GUID of object to traverse
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER PobjGuid AS CHARACTER NO-UNDO.

  DEFINE VARIABLE Mpos AS INTEGER NO-UNDO.

  DEFINE BUFFER Brtb_object  FOR rtb.rtb_object.
  DEFINE BUFFER Brtb_xref    FOR rtb.rtb_xref.

  ASSIGN
    MnumLevels = MnumLevels + 1.
    MtotLevels = MAX(MtotLevels, MnumLevels).

  /*
   Build temporty list of objects calling the current object
  */
  FOR EACH Brtb_xref NO-LOCK
    WHERE Brtb_xref.ref-object-guid-1 = PobjGuid:

    FIND Brtb_object NO-LOCK
      WHERE Brtb_object.object-guid = Brtb_xref.src-object-guid NO-ERROR.

    IF NOT AVAILABLE Brtb_object THEN NEXT.

    IF Brtb_object.obj-type <> "PCODE":U THEN NEXT.

    ASSIGN
      MobjCtrl = MobjCtrl + TRIM(STRING(MnumLevels,">9")) + ","
      Mpos     = LOOKUP(Brtb_object.object,MobjList).

    IF Mpos <> 0 OR MnumLevels > MmaxLevels THEN DO:
      MobjList = MobjList +
                 (IF MnumLevels > MmaxLevels THEN
                    "*"
                  ELSE
                    "[" + TRIM(STRING(Mpos,">>>9")) + "]") +
                  Brtb_object.object + ",".
      NEXT.                   
    END.
    ELSE DO:
      MobjList = MobjList + Brtb_object.object + ",".
      RUN rtb_build_structure_chart2 (Brtb_xref.src-object-guid).
    END.
  END.

  MnumLevels = MnumLevels - 1.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_external_objects) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_external_objects Procedure 
PROCEDURE rtb_external_objects :
/*------------------------------------------------------------------------------
  Purpose:    Report all references to objects that are external to the workspace
  Parameters: INPUT Pwspace - workspace id
  Notes:      This report is divided into two sections: external RUN references
              and external INCLUDE references.  In the first section, internal
              procedures that resides in procedures external to the workspace are
              shown as well.
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace AS CHARACTER NO-UNDO.

  DEFINE VARIABLE Mref-type AS CHARACTER FORMAT "x(16)" NO-UNDO.

  DEFINE BUFFER Brtb_wspace FOR rtb.rtb_wspace.
  DEFINE BUFFER Brtb_object FOR rtb.rtb_object.
  DEFINE BUFFER Brtb_xref   FOR rtb.rtb_xref.

  FIND Brtb_wspace NO-LOCK
    WHERE Brtb_wspace.wspace-id = Pwspace.

  /*
   Build a temp-table of all RUN references to informal objects.. 
  */
  FOR EACH Brtb_object NO-LOCK
    WHERE Brtb_object.wspace-id = Pwspace
      AND Brtb_object.obj-type  = "PCODE":U,
      EACH Brtb_xref NO-LOCK
    WHERE Brtb_xref.src-object-guid = Brtb_object.object-guid
      AND Brtb_xref.ref-type = {&XREF_PROG}
      AND Brtb_xref.ref-object-guid-1 = "":

    CREATE ttXref.
    BUFFER-COPY Brtb_xref TO ttXref.

  END.  /* each Brtb_object */

  /*
   Since internal procedure show up as {XREF_PROG}, find all references to
   internal procedure in the given workspace and remove them from our list.
  */
  FOR EACH Brtb_xref NO-LOCK
    WHERE Brtb_xref.wspace-guid = Brtb_wspace.wspace-guid
      AND Brtb_xref.ref-type    = {&XREF_INTPROC}
    BREAK BY Brtb_xref.obj-text:

    IF FIRST-OF(Brtb_xref.obj-text) THEN DO:

      FOR EACH ttXref
         WHERE ttXref.wspace-guid = Brtb_wspace.wspace-guid
           AND ttXref.ref-type    = {&XREF_PROG}
           AND ttXref.obj-text    = Brtb_xref.obj-text:
        DELETE ttXref.
      END.

    END. /* first-of */
    
  END. /* each Brtb_xref */

  /*
   Print the report based on the contents of our temp-table.. 
  */
  FOR EACH ttXref
    BY ttXref.obj-text
    WITH FRAME ext-prog-obj-frame:

    {rtb/i/rtb_rpthdr.i
      &title="""External Objects Report"""
      &criteria="""Workspace:"" Pwspace SKIP"
      &center-criteria=NO
      &frame-no=1
      &stream=Sout}

    FIND Brtb_object NO-LOCK
      WHERE Brtb_object.object-guid = ttXref.src-object-guid NO-ERROR.

    Mref-type = ENTRY(ttXref.ref-type,"{&XREF-TYPE-LIST}").

    DISPLAY STREAM Sout
      ttXref.obj-text    FORMAT "x(40)" COLUMN-LABEL "External Reference"
      Brtb_object.object FORMAT "x(50)" COLUMN-LABEL "Referenced By"
      Mref-type                         COLUMN-LABEL "Ref Type"
      WITH STREAM-IO WIDTH 120.
      
  END.

  /*
   Print all external include references.. 
  */
  FOR EACH Brtb_xref NO-LOCK
    WHERE Brtb_xref.wspace-guid = Brtb_wspace.wspace-guid
      AND Brtb_xref.ref-type = {&XREF_XINCLD},
           Brtb_object NO-LOCK
    WHERE Brtb_object.object-guid = Brtb_xref.src-object-guid
    BY Brtb_xref.obj-text 
    WITH FRAME ext-inc-obj-frame:

    {rtb/i/rtb_rpthdr.i
      &title="""External Objects Report"""
      &criteria="""Workspace:"" Pwspace SKIP(1)"
      &center-criteria=NO
      &frame-no=2
      &STREAM=Sout}

    Mref-type = ENTRY(Brtb_xref.ref-type,"{&XREF-TYPE-LIST}").

    DISPLAY STREAM Sout
      Brtb_xref.obj-text FORMAT "x(40)" COLUMN-LABEL "External Reference"
      Brtb_object.object FORMAT "x(50)" COLUMN-LABEL "Referenced By"
      Mref-type                         COLUMN-LABEL "Ref Type"
      WITH STREAM-IO WIDTH 120.
      
  END.

  {rtb/i/rtb_rptftr.i &STREAM=Sout}

  EMPTY TEMP-TABLE ttXref.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_index_usage) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_index_usage Procedure 
PROCEDURE rtb_index_usage :
/*------------------------------------------------------------------------------
  Purpose:     Print a summary of index usage based on selected criteria.
  Parameters:  INPUT Pwspace    - workspace id
               INPUT PunusedSum - True for unused index summary
               INPUT TTfile     - selected tables
               INPUT TTindex    - selected indexes
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace    AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER PunusedSum AS LOGICAL   NO-UNDO.
  DEFINE INPUT PARAMETER TABLE FOR TTFile.
  DEFINE INPUT PARAMETER TABLE FOR TTIndex.

  DEFINE VARIABLE Mtable       AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE Mdescription AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE MtextLines   AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE MsrcType     AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE MfileObj     AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE MindexUsed   AS LOGICAL    NO-UNDO.

  DEFINE BUFFER Brtb_object  FOR rtb.rtb_object.
  DEFINE BUFFER Brtb_wspace  FOR rtb.rtb_wspace.
  DEFINE BUFFER B2rtb_object FOR rtb.rtb_object.
  DEFINE BUFFER Brtb_xref    FOR rtb.rtb_xref.
  DEFINE BUFFER Brtb_index   FOR rtb.rtb_index.

  FIND Brtb_wspace WHERE
       Brtb_wspace.wspace-id = Pwspace NO-LOCK NO-ERROR.

  IF NOT AVAILABLE Brtb_wspace THEN DO:
    RETURN "Workspace record is not available.".
  END.

  /*
   If there are records in the index temp-table, that means more than
   one table was selected.  Go and fetch and the indexes for this table..
  */
  IF NOT CAN-FIND(FIRST TTindex) THEN DO:
    FOR EACH TTfile:
      FIND Brtb_object WHERE
           Brtb_object.wspace-id = Pwspace AND
           Brtb_object.obj-type  = "PFILE":U AND
           Brtb_object.OBJECT    = TTfile.fileObject NO-LOCK NO-ERROR.

      IF AVAILABLE Brtb_object THEN DO:
        FOR EACH Brtb_index WHERE
                 Brtb_index.pmod     = Brtb_object.pmod AND
                 Brtb_index.obj-type = Brtb_object.obj-type AND
                 Brtb_index.object   = Brtb_object.object AND
                 Brtb_index.version  = Brtb_object.version NO-LOCK:

          CREATE TTIndex.
          ASSIGN TTIndex.fileObject = TTFile.fileObject
                 TTIndex.indexName  = Brtb_index.rtb_index-name.    
        END.
      END.
    END.
  END.

  /*
   If running the Unused Index Summary, build a temp table of all
   tables in the workspace and their indexes.
  */
  IF PunusedSum THEN DO:
    FOR EACH Brtb_object WHERE
             Brtb_object.wspace-id = Pwspace AND
             Brtb_object.obj-type  = "PFILE":U NO-LOCK:

      CREATE TTfile.
      ASSIGN TTfile.fileObject = Brtb_object.OBJECT.

      FOR EACH Brtb_index WHERE
               Brtb_index.pmod     = Brtb_object.pmod AND
               Brtb_index.obj-type = Brtb_object.obj-type AND
               Brtb_index.object   = Brtb_object.object AND
               Brtb_index.version  = Brtb_object.version NO-LOCK:

        CREATE TTIndex.
        ASSIGN TTIndex.fileObject = TTFile.fileObject
               TTIndex.indexName  = Brtb_index.rtb_index-name.    
      END.
    END.
  END. /* PunusedSum */
  
  FORM MfileObj              LABEL "File"     FORMAT "x(35)"
       TTindex.indexName     LABEL "Index"    FORMAT "x(25)"
       MsrcType              LABEL "Src Type"
       Mdescription          LABEL "Object"   FORMAT "x(35)"
       Brtb_xref.ref-actions LABEL "Actions"  
       WITH FRAME report-detail DOWN STREAM-IO WIDTH 120.
       
  {rtb/i/rtb_rpthdr.i
      &title="""Index Usage Report"""
      &criteria="""Workspace:"" Pwspace FORMAT ""x(30)"" SKIP"
      &center-criteria=NO
      &STREAM=Sout}

  IF PunusedSum THEN
    PUT STREAM Sout "**Unused Index Summary**" SKIP.

  FOR EACH TTFile
    BREAK BY TTFile.fileObject:
      
    IF FIRST-OF(TTFile.fileObject) THEN DO:

      FIND FIRST Brtb_object WHERE 
                 Brtb_object.wspace-id = Pwspace AND
                 Brtb_object.obj-type  = "PFILE":U AND
                 Brtb_object.object    = TTFile.fileObject NO-LOCK NO-ERROR.
                 
      MfileObj = Brtb_object.object.
                 
    END.

    FOR EACH TTIndex WHERE
             TTIndex.fileObject = TTFile.fileObject
      BREAK BY TTindex.fileObject
            BY TTindex.indexName:

      MindexUsed = NO.

      FOR EACH Brtb_xref WHERE
               Brtb_xref.ref-object-guid-1 = Brtb_object.object-guid AND
               Brtb_xref.ref-type          = {&XREF_INDEX} AND
               Brtb_xref.obj-text          = TTIndex.IndexName NO-LOCK
        BREAK BY Brtb_xref.obj-text:

        ASSIGN MindexUsed = YES
               MsrcType   = ENTRY(Brtb_xref.src-type,"{&XREF-TYPE-LIST}").

        FIND B2rtb_object WHERE
          B2rtb_object.object-guid = Brtb_xref.src-object-guid NO-LOCK NO-ERROR.

        IF NOT AVAILABLE B2rtb_object THEN NEXT.
        
        
        /*
        This can be used to get a description string of the referenced Object.
        
        RUN rtb_get_object_version_details (INPUT B2rtb_object.pmod,
                                            INPUT B2rtb_object.obj-type,
                                            INPUT B2rtb_object.object,
                                            INPUT B2rtb_object.version,
                                            OUTPUT Mdescription,
                                            OUTPUT MtextLines).

        Mdescription = B2rtb_object.OBJECT + " / " + Mdescription.
        */

        IF NOT PunusedSum THEN DO:
          
          DISPLAY STREAM Sout
            MfileObj 
            TTindex.indexName WHEN FIRST-OF(Brtb_xref.obj-text)
            MsrcType      
            B2rtb_object.object @ Mdescription  
            Brtb_xref.ref-actions
            WITH FRAME report-detail.
            
          DOWN STREAM Sout WITH FRAME report-detail.
          
          MfileObj = "". /* reset to blank so it only displays on first use */
          
        END.

      END.  /* each xref */

      /*
       If index was not used, display this to the user
      */
      IF NOT MindexUsed THEN DO:

        DISPLAY STREAM Sout
          MfileObj
          TTindex.indexName
          "*UNUSED*"       @ MsrcType
          ""               @ Mdescription
          ""               @ Brtb_xref.ref-actions 
          WITH FRAME report-detail.
          
        DOWN STREAM Sout WITH FRAME report-detail.

        MfileObj = "". /* reset to blank so it only displays on first use */
        
      END. /* if not midx-used */

    END. /* each TTIndex */

    /*
     Only skip if something about the current ttFile has been printed
     to avoid an extra blank line.
    */
    IF MfileObj = "" THEN 
      PUT STREAM Sout SKIP(1).
    
  END. /* each TTFile */

  {rtb/i/rtb_rptftr.i &STREAM=Sout}

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_informal_xref) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_informal_xref Procedure 
PROCEDURE rtb_informal_xref :
/*------------------------------------------------------------------------------
  Purpose:     Print informal object usage of selected type
  Parameters:  INPUT Pwspace - workspace id
               INPUT Ptype   - informal xref type
               INPUT Pobject - object id
  Notes:      
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Ptype   AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Pobject AS CHARACTER NO-UNDO.

  DEFINE VARIABLE Mdescription AS CHARACTER NO-UNDO.
  DEFINE VARIABLE MsrcType     AS CHARACTER NO-UNDO.
  DEFINE VARIABLE MtextLines   AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mtype        AS CHARACTER NO-UNDO.
  DEFINE VARIABLE MtypeNum     AS INTEGER   NO-UNDO.

  DEFINE BUFFER Brtb_wspace FOR rtb.rtb_wspace.
  DEFINE BUFFER Brtb_xref   FOR rtb.rtb_xref.
  DEFINE BUFFER Brtb_object FOR rtb.rtb_object.

  FIND Brtb_wspace NO-LOCK
    WHERE Brtb_wspace.wspace-id = Pwspace NO-ERROR.

  IF NOT AVAILABLE Brtb_wspace THEN
    RETURN "Workspace record is not available.".
  
  MtypeNum = LOOKUP(Ptype,"{&XREF-TYPE-LIST}").

  {rtb/i/rtb_rpthdr.i
      &title="""Informal Xref Report"""
      &criteria="""Workspace:"" Pwspace FORMAT ""x(30)"" SKIP
                 ""Ref Type :"" Ptype   FORMAT ""x(30)"" SKIP
                 ""Object   :"" Pobject FORMAT ""x(30)"" SKIP(1)"
      &center-criteria=NO
      &STREAM=Sout}

  FOR EACH Brtb_xref NO-LOCK
    WHERE Brtb_xref.wspace-guid = Brtb_wspace.wspace-guid
      AND Brtb_xref.ref-type    = MtypeNum
      AND Brtb_xref.obj-text    = Pobject:

    MsrcType = ENTRY(Brtb_xref.src-type,"{&XREF-TYPE-LIST}").

    FIND Brtb_object NO-LOCK 
      WHERE Brtb_object.object-guid = Brtb_xref.src-object-guid NO-ERROR.

    IF NOT AVAILABLE Brtb_object THEN NEXT.

    RUN rtb_get_object_version_details (INPUT Brtb_object.pmod,
                                        INPUT Brtb_object.obj-type,
                                        INPUT Brtb_object.object,
                                        INPUT Brtb_object.version,
                                        OUTPUT Mdescription,
                                        OUTPUT MtextLines).

    Mdescription = Brtb_object.object + " / " + Mdescription.

    DISPLAY STREAM Sout
      MsrcType              FORMAT "x(16)" LABEL "Type"
      Mdescription          FORMAT "x(70)" LABEL "Object"
      Brtb_xref.ref-actions                LABEL "Actions"
      WITH STREAM-IO WIDTH 120.

  END.

  {rtb/i/rtb_rptftr.i &STREAM=Sout}

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_object_call_diagram) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_object_call_diagram Procedure 
PROCEDURE rtb_object_call_diagram :
/*------------------------------------------------------------------------------
  Purpose:     Print a hierarchy of instantiated objects, classes, etc based on
               selected object
  Parameters:  INPUT Pwspace     - workspace id
               INPUT Pobject     - object id
               INPUT PmaxLevels  - levels to traverse
               INPUT PwhiteSpace - amount of space in report nodes
               INPUT Pspacing    - TRUE for double-spaced output
               INPUT Pmod        - product module
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace     AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Pobject     AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER PmaxLevels  AS INTEGER   NO-UNDO.
  DEFINE INPUT PARAMETER PwhiteSpace AS INTEGER   NO-UNDO.
  DEFINE INPUT PARAMETER Pspacing    AS LOGICAL   NO-UNDO.
  DEFINE INPUT PARAMETER Ppmod       AS CHARACTER NO-UNDO.
  
  DEFINE VARIABLE Mspaces    AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mobject    AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mline      AS CHARACTER NO-UNDO.
  DEFINE VARIABLE McurLevel  AS INTEGER   NO-UNDO.
  DEFINE VARIABLE Mi         AS INTEGER   NO-UNDO.
  DEFINE VARIABLE Mj         AS INTEGER   NO-UNDO.
  DEFINE VARIABLE Mfirst     AS LOGICAL   NO-UNDO.

  DEFINE BUFFER Brtb_object FOR rtb.rtb_object.
  DEFINE BUFFER Brtb_ver    FOR rtb.rtb_ver.
  DEFINE BUFFER Brtb_xref   FOR rtb.rtb_xref.

  FIND Brtb_object NO-LOCK 
    WHERE Brtb_object.wspace-id = Pwspace 
      AND Brtb_object.obj-type  = "PCODE":U 
      AND Brtb_object.OBJECT    = Pobject 
      AND Brtb_object.pmod      = Ppmod NO-ERROR.

  IF NOT AVAILABLE Brtb_object THEN DO:
    RETURN "Object record is not available.".
  END.

  ASSIGN MmaxLevels = PmaxLevels
         MnumLevels = 1
         MobjCtrl   = "1,".

  RUN rtb_build_structure_chart (Brtb_object.object-guid).

  ASSIGN Mspaces   = FILL(" ",MIN(PwhiteSpace,INTEGER((64 - MtotLevels) / MtotLevels)))
         McurLevel = 1
         Mfirst    = YES.

  DO Mi = 1 TO NUM-ENTRIES(MobjCtrl):

    RELEASE Brtb_object.
    RELEASE Brtb_ver.
    RELEASE Brtb_xref.

    Mobject = ENTRY(Mi,MobjList). 

    IF Mobject = "" THEN NEXT.

    /*
     Is we are running an informal object (or invoking a method)..
    */
    IF Mobject BEGINS "RV":U OR Mobject BEGINS "IN":U THEN DO:  
      
      FIND Brtb_xref WHERE
        ROWID(Brtb_xref) = TO-ROWID(SUBSTRING(Mobject,4)) NO-LOCK NO-ERROR.

      IF Mobject BEGINS "RV":U THEN 
        Mobject = "RUN ":U.
      ELSE
        Mobject = "INVOKE ":U.
    END.
    ELSE IF Mobject BEGINS "[" THEN
      FIND Brtb_object WHERE
           Brtb_object.wspace-id = Pwspace AND
           Brtb_object.obj-type  = "PCODE":U AND
           Brtb_object.object    =  SUBSTRING(Mobject,INDEX(Mobject,"]") + 1) NO-LOCK NO-ERROR.
    ELSE IF Mobject BEGINS "*" THEN
      FIND Brtb_object WHERE
           Brtb_object.wspace-id = Pwspace AND
           Brtb_object.obj-type  = "PCODE":U AND
           Brtb_object.object    = SUBSTRING(Mobject,2) NO-LOCK NO-ERROR.
    ELSE
      FIND Brtb_object WHERE
           Brtb_object.wspace-id = Pwspace AND
           Brtb_object.obj-type  = "PCODE":U AND
           Brtb_object.object    = Mobject NO-LOCK NO-ERROR.

    IF AVAILABLE Brtb_object THEN
      FIND Brtb_ver OF Brtb_object NO-LOCK.

    /*
     If we have an actual object, add the description next to it.  If we an
     informal object that is either ran or invoked, print the approriate value
     from obj-text or ref-text.
    */
    Mobject =
      Mobject +
        IF AVAILABLE Brtb_ver THEN
          " / " + Brtb_ver.description
        ELSE
          (IF AVAILABLE Brtb_xref AND Mobject BEGINS "RUN " THEN
             Brtb_xref.ref-text
           ELSE IF AVAILABLE Brtb_xref AND Mobject BEGINS "INVOKE " THEN  
             Brtb_xref.obj-text
           ELSE
             "") +
            " / ** cannot follow to next level **".

    ASSIGN McurLevel = INTEGER(ENTRY(MI,MobjCtrl))
           Mline      = STRING(Mi,">>>>9") + " ".

    DO Mj = 2 TO McurLevel:
      Mline = Mline + "|" + Mspaces.
    END.

    {rtb/i/rtb_rpthdr.i 
       &title="""Call Diagram Report"""
       &criteria=""" Workspace:"" Pwspace    FORMAT ""x(30)"" SKIP
                  ""    Object:"" Pobject    FORMAT ""x(100)"" SKIP
                  ""Max Levels:"" MmaxLevels FORMAT "">9""
                 SKIP(1)"
       &center-criteria=NO
       &STREAM=Sout}

    PUT STREAM Sout Mline + Mobject FORMAT "x(120)" SKIP.

    IF Pspacing THEN
      PUT STREAM Sout FILL(" ",5) + SUBSTRING(Mline,6) + "|" FORMAT "x(120)" SKIP.
    

  END.  /* do mi = 1 to NUM-ENTRIES(MobjCtrl) */

  PUT STREAM Sout SKIP(1) "[###] = see line ###,  * = max levels hit but more exist." SKIP(1).

  {rtb/i/rtb_rptftr.i &STREAM=Sout}

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_object_usage_diagram) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_object_usage_diagram Procedure 
PROCEDURE rtb_object_usage_diagram :
/*------------------------------------------------------------------------------
  Purpose:     Print a hierarchy of objects, classes, etc that reference selected
               object
  Parameters:  INPUT Pwspace     - workspace id
               INPUT Pobject     - object id
               INPUT PmaxLevels  - levels to traverse
               INPUT PwhiteSpace - amount of space in report nodes
               INPUT Pspacing    - TRUE for double-spaced output
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace     AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Pobject     AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER PmaxLevels  AS INTEGER   NO-UNDO.
  DEFINE INPUT PARAMETER PwhiteSpace AS INTEGER   NO-UNDO.
  DEFINE INPUT PARAMETER Pspacing    AS LOGICAL   NO-UNDO.
  DEFINE INPUT PARAMETER Ppmod       AS CHARACTER NO-UNDO.

  DEFINE VARIABLE Mspaces    AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mobject    AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mline      AS CHARACTER NO-UNDO.
  DEFINE VARIABLE McurLevel  AS INTEGER   NO-UNDO.
  DEFINE VARIABLE Mi         AS INTEGER   NO-UNDO.
  DEFINE VARIABLE Mj         AS INTEGER   NO-UNDO.
  DEFINE VARIABLE Mfirst     AS LOGICAL   NO-UNDO.

  DEFINE BUFFER Brtb_object FOR rtb.rtb_object.
  DEFINE BUFFER Brtb_ver    FOR rtb.rtb_ver.
  DEFINE BUFFER Brtb_xref   FOR rtb.rtb_xref.

  FIND Brtb_object NO-LOCK 
    WHERE Brtb_object.wspace-id = Pwspace
      AND Brtb_object.obj-type  = "PCODE":U 
      AND Brtb_object.OBJECT    = Pobject 
      AND Brtb_object.pmod      = Ppmod  NO-ERROR.

  IF NOT AVAILABLE Brtb_object THEN DO:
    RETURN "Object record is not available.".
  END.

  ASSIGN MmaxLevels = PmaxLevels
         MnumLevels = 1
         MobjCtrl   = "1,"
         MobjList   = Brtb_object.object + ",".

  RUN rtb_build_structure_chart2 (Brtb_object.object-guid).

  ASSIGN Mspaces   = FILL(" ",MIN(PwhiteSpace,INTEGER((64 - MtotLevels) /  MtotLevels)))
         McurLevel = 1.

  {rtb/i/rtb_rpthdr.i 
     &title="""Object Usage Report"""
     &criteria=""" Workspace:"" Pwspace    FORMAT ""x(30)"" SKIP
                ""    Object:"" Pobject    FORMAT ""x(30)"" SKIP
                ""Max Levels:"" MmaxLevels FORMAT "">9""
               SKIP(1)"
     &center-criteria=NO
     &STREAM=Sout}

  DO Mi = 1 TO NUM-ENTRIES(MobjCtrl):

    Mobject = ENTRY(Mi,MobjList). 

    IF Mobject = "" THEN LEAVE.

    IF Mobject BEGINS "[" THEN
      FIND Brtb_object WHERE
           Brtb_object.wspace-id = Pwspace AND
           Brtb_object.obj-type  = "PCODE":U AND
           Brtb_object.object    =  SUBSTRING(Mobject,INDEX(Mobject,"]") + 1) NO-LOCK NO-ERROR.
    ELSE IF Mobject BEGINS "*" THEN
      FIND Brtb_object WHERE
           Brtb_object.wspace-id = Pwspace AND
           Brtb_object.obj-type  = "PCODE":U AND
           Brtb_object.object    = SUBSTRING(Mobject,2) NO-LOCK NO-ERROR.
    ELSE
      FIND Brtb_object WHERE
           Brtb_object.wspace-id = Pwspace AND
           Brtb_object.obj-type  = "PCODE":U AND
           Brtb_object.object    = Mobject NO-LOCK NO-ERROR.

    IF AVAILABLE Brtb_object THEN
      FIND Brtb_ver OF Brtb_object NO-LOCK.

    IF AVAILABLE Brtb_ver THEN 
      Mobject = Mobject + " / " + Brtb_ver.description.

    ASSIGN McurLevel = INTEGER(ENTRY(Mi,MobjCtrl))
           Mline     = STRING(Mi,">>>>9") + " ".

    DO Mj = 2 TO McurLevel:
      Mline = Mline + "|" + Mspaces.
    END.

    PUT STREAM Sout Mline + Mobject FORMAT "x(120)" SKIP.

    IF Pspacing THEN
      PUT STREAM Sout FILL(" ",5) + SUBSTRING(Mline,6) + "|"  FORMAT "x(120)" SKIP.

  END.  /* do Mi = 1 to NUM-ENTRIES(Mobj-ctrl) */

  PUT STREAM Sout SKIP(1) "[###] = see line ###,  * = max levels hit but more exist." SKIP(1).

  {rtb/i/rtb_rptftr.i &STREAM=Sout}

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_object_where_used) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_object_where_used Procedure 
PROCEDURE rtb_object_where_used :
/*------------------------------------------------------------------------------
  Purpose:     Print all objects that reference selected object
  Parameters:  INPUT Pwspace  - workspace id
               INPUT PobjType - object type
               INPUT Pobject  - object id
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace  AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER PobjType AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Pobject  AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Ppmod    AS CHARACTER NO-UNDO.

  DEFINE VARIABLE Mdescription       AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mtext-lines        AS CHARACTER NO-UNDO.

  DEFINE BUFFER Brtb_xref    FOR rtb.rtb_xref.
  DEFINE BUFFER Brtb_object  FOR rtb.rtb_object.
  DEFINE BUFFER B2rtb_object FOR rtb.rtb_object.

  DO ON ERROR UNDO, LEAVE:

    IF LOOKUP (PobjType,"PDBASE,PFILE,PFIELD") <> 0 THEN 
      FIND Brtb_object NO-LOCK
        WHERE Brtb_object.wspace-id = Pwspace
          AND Brtb_object.obj-type  = PobjType
          AND Brtb_object.object    = Pobject NO-ERROR.
    ELSE 
      FIND Brtb_object NO-LOCK
        WHERE Brtb_object.wspace-id = Pwspace
          AND Brtb_object.obj-type  = PobjType
          AND Brtb_object.object    = Pobject 
          AND Brtb_object.pmod      = Ppmod NO-ERROR.

    IF NOT AVAILABLE Brtb_object THEN
      RETURN "Object record is not available.".

    {rtb/i/rtb_rpthdr.i 
       &title="""Where Used Report"""
       &criteria="""Workspace:"" Pwspace  SKIP
                  ""     Type:""  PobjType SKIP
                  ""   Object:""  Pobject  FORMAT ""X(54)""
                 SKIP(1)"
       &center-criteria=NO
       &STREAM=Sout}

    /*
     Build temp-table
    */
    FOR EACH Brtb_xref NO-LOCK
      WHERE Brtb_xref.ref-object-guid-1 = Brtb_object.object-guid:

      FIND FIRST B2rtb_object NO-LOCK
        WHERE B2rtb_object.object-guid = Brtb_xref.src-object-guid NO-ERROR.

      CREATE TTwhere.
      ASSIGN TTwhere.obj-guid    = Brtb_xref.src-object-guid
             TTwhere.ref-type    = ENTRY(Brtb_xref.ref-type,"{&XREF-TYPE-LIST}")
             TTwhere.src-type    = ENTRY(Brtb_xref.src-type,"{&XREF-TYPE-LIST}")
             TTwhere.ref-actions = Brtb_xref.ref-actions.

      IF AVAILABLE B2rtb_object THEN
        TTwhere.object = B2rtb_object.object.
      ELSE
        IF Brtb_xref.src-object-guid > "" THEN
          TTwhere.object = "*Stale object ID*".
        ELSE
          TTwhere.object = Brtb_xref.obj-text.
    
    END. /* each Brtb_xref */

    /* print xrefs */
    FOR EACH TTwhere:

       DISPLAY STREAM Sout
          TTwhere.ref-type     FORMAT "x(16)"
          TTwhere.src-type     FORMAT "x(16)"
          TTwhere.OBJECT       FORMAT "x(45)" LABEL "Object"
          TTwhere.ref-actions                 LABEL "Actions"
          WITH WIDTH 120 NO-BOX STREAM-IO.

    END.  /* for each TTwhere */  

    {rtb/i/rtb_rptftr.i &STREAM=Sout}

  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_object_xref) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_object_xref Procedure 
PROCEDURE rtb_object_xref :
/*------------------------------------------------------------------------------
  Purpose:     Print all objects that are referenced by selected object
  Parameters:  INPUT Pwspace  - workspace id
               INPUT PobjType - object type
               INPUT Pobject  - object id               
               INPUT Ppmod    - pmod
               
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace  AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER PobjType AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER Pobject  AS CHARACTER NO-UNDO.  
  DEFINE INPUT PARAMETER Ppmod    AS CHARACTER NO-UNDO.
  

  DEFINE VARIABLE MrefType     AS CHARACTER NO-UNDO.
  DEFINE VARIABLE Mdescription AS CHARACTER NO-UNDO.
  DEFINE VARIABLE MtextLines   AS CHARACTER NO-UNDO.

  DEFINE BUFFER Brtb_xref    FOR rtb.rtb_xref.
  DEFINE BUFFER Brtb_object  FOR rtb.rtb_object.
  DEFINE BUFFER B2rtb_object FOR rtb.rtb_object.

  IF LOOKUP (PobjType,"PDBASE,PFILE,PFIELD") <> 0 THEN 
    FIND Brtb_object NO-LOCK
      WHERE Brtb_object.wspace-id = Pwspace
        AND Brtb_object.obj-type  = PobjType
        AND Brtb_object.object    = Pobject NO-ERROR.
  ELSE 
    FIND Brtb_object NO-LOCK
      WHERE Brtb_object.wspace-id = Pwspace
        AND Brtb_object.obj-type  = PobjType
        AND Brtb_object.object    = Pobject 
        AND Brtb_object.pmod      = Ppmod NO-ERROR.

  IF NOT AVAILABLE Brtb_object THEN
    RETURN "Object record is not available.".
  
  {rtb/i/rtb_rpthdr.i 
     &title="""Xref Report"""
     &criteria="""Workspace:"" Pwspace  SKIP
               ""     Type:""  PobjType SKIP
               ""   Object:""  Pobject  FORMAT ""X(54)""
               SKIP(1)"
     &center-criteria=NO
     &STREAM=Sout}

  FOR EACH Brtb_xref NO-LOCK
    WHERE Brtb_xref.src-object-guid = Brtb_object.object-guid:

    MrefType = ENTRY(Brtb_xref.ref-type,"{&XREF-TYPE-LIST}").

    IF CAN-DO("{&XREF_PARAM},
               {&XREF_SVAR},
               {&XREF_SBUF},
               {&XREF_SWF},
               {&XREF_SFRM},
               {&XREF_WFLD},
               {&XREF_GVAR},
               {&XREF_DICT_FILE},
               {&XREF_DICT_FIELD},
               {&XREF_DICT_INDEX},
               {&XREF_PART},
               {&XREF_XINCLD},
               {&XREF_SWT},
               {&XREF_SEQ},
               {&XREF_DLL},
               {&XREF_FUNC},
               {&XREF_EVENT}",TRIM(STRING(Brtb_xref.ref-type))) THEN
      Mdescription = Brtb_xref.obj-text.
    ELSE IF Brtb_xref.ref-object-guid-1 = "" THEN
      Mdescription = Brtb_xref.obj-text.
    ELSE DO:
      FIND B2rtb_object WHERE
        B2rtb_object.object-guid = Brtb_xref.ref-object-guid-1 NO-LOCK NO-ERROR.

      IF NOT AVAILABLE B2rtb_object THEN
        Mdescription = Brtb_xref.obj-text.
      ELSE DO:
        RUN rtb_get_object_version_details (INPUT B2rtb_object.pmod,
                                            INPUT B2rtb_object.obj-type,
                                            INPUT B2rtb_object.object,
                                            INPUT B2rtb_object.version,
                                            OUTPUT Mdescription,
                                            OUTPUT MtextLines).

        IF CAN-DO("{&XREF_FILE},
                   {&XREF_INDEX},
                   {&XREF_INCLD},
                   {&XREF_FIELD},
                   {&XREF_TFLD}",TRIM(STRING(Brtb_xref.ref-type))) AND Brtb_object.obj-type <> "PCODE":U THEN
         ASSIGN Mdescription = Brtb_xref.obj-text + " / " + Mdescription
                MtextLines   = STRING("Object: " + B2rtb_object.object,"x(76)") + MtextLines.
         ELSE
           Mdescription = B2rtb_object.object + " / " + Mdescription.
      END.
      
    END.

    DISPLAY STREAM Sout
      MrefType     FORMAT "x(16)" LABEL "Type"
      Mdescription FORMAT "x(80)" LABEL "Reference"
      Brtb_xref.ref-actions       LABEL "Actions"
      WITH WIDTH 120 NO-BOX STREAM-IO.

   END.  /* for each rtb_xref */

  {rtb/i/rtb_rptftr.i &STREAM=Sout}

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_unused_objects) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_unused_objects Procedure 
PROCEDURE rtb_unused_objects :
/*------------------------------------------------------------------------------
  Purpose:     Print all unreferenced objects in selected workspace
  Parameters:  INPUT Pwspace - wspace id
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace AS CHARACTER NO-UNDO.

  DEFINE BUFFER Brtb_object FOR rtb.rtb_object.
  DEFINE BUFFER Brtb_xref   FOR rtb.rtb_xref.
  DEFINE BUFFER Brtb_ver    FOR rtb.rtb_ver.

  {rtb/i/rtb_rpthdr.i 
    &title="""Unused Objects Report"""
    &criteria="""Workspace:"" Pwspace SKIP
              SKIP(1)"
    &center-criteria=NO
    &STREAM=Sout}

  FOR EACH Brtb_object NO-LOCK
    WHERE Brtb_object.wspace-id = Pwspace
      AND CAN-DO("PCODE,PFILE,PFIELD",Brtb_object.obj-type):

    IF CAN-FIND(FIRST Brtb_xref
                  WHERE Brtb_xref.ref-object-guid-1 = Brtb_object.object-guid) THEN NEXT. 

    FIND Brtb_ver OF Brtb_object NO-LOCK.

    DISPLAY STREAM Sout
      Brtb_object.obj-type
      Brtb_object.object + " / " + Brtb_ver.description FORMAT "x(100)" LABEL "Object / Description"
      WITH STREAM-IO WIDTH 120. 

  END.

  {rtb/i/rtb_rptftr.i &STREAM=Sout}

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

